<!--
# @OSF_COPYRIGHT@
# 
# 
# HISTORY
# $Log: 3o_example_05.c,v $
# Revision 1.1.2.2  1996/11/05  20:11:54  weir
# 	Cleaned up history
# 	[1996/11/05  20:11:00  weir]
#
# Revision 1.1.2.1  1996/10/28  19:46:27  wardr
# 	{edit,R1.2.2}
# 	Initial checkin after sgml conversion
# 	[1996/10/28  19:46:00  wardr]
# 
# Revision 1.1.1.2  1996/10/28  19:46:00  wardr
# 	{edit,R1.2.2}
# 	Initial checkin after sgml conversion
# 
# $EndLog$
-->
<!---->
<!-- Fragment document type declaration subset:
ArborText, Inc., 1988-1993, v.4001
<!DOCTYPE Book PUBLIC "-//Davenport//DTD DocBook V2.4//EN" [
]>
-->
<!--  -->
<!--  -->
<!-- COPYRIGHT NOTICE -->
<!-- Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc. -->
<!-- ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE in the -->
<!-- src directory for the full copyright text. -->
<!--  -->
<!--  -->
<!-- HISTORY -->
<!--  -->
<!-- Revision 1.1.4.5  1995/06/07  16:47:42  buckler -->
<!-- 	1.1 edits. -->
<!-- 	PRENTICE HALL reformat. -->
<!-- 	[1995/06/01  20:51:45  buckler] -->
<!--  -->
<!-- Revision 1.1.4.4  1994/07/13  19:46:40  jshirley -->
<!-- 	{def,10220,R1.1} Remove reference to rpcd and sec_clientd -->
<!-- 	[1994/07/13  19:46:17  jshirley] -->
<!--  -->
<!-- Revision 1.1.4.3  1993/01/29  17:19:18  cjd -->
<!-- 	Embedded copyright notice -->
<!-- 	[1993/01/29  17:03:07  cjd] -->
<!--  -->
<!-- Revision 1.1.4.2  1992/09/01  16:30:16  weir -->
<!-- 	Moved -->
<!-- 	[1992/09/01  16:22:14  weir] -->
<!--  -->
<!-- Revision 1.1.2.2  1992/03/06  16:33:20  steiner -->
<!-- 	replaced comment leader -->
<!-- 	[1992/03/06  15:47:04  steiner] -->
<!--  -->
<!-- Revision 1.1  1992/01/29  15:40:54  damon -->
<!-- 	Initial revision -->
<!--  -->
<!--  -->
<!--  -->
/* 
 * greet_server.c
 *
 * Main program (initialization) for "greet" server.
 */

#include &lt;stdio.h>
#include &lt;dce/dce_error.h>
#include &lt;dce/rpc.h>

#include "greet.h"
#include "util.h"

int
main(
    int argc,
    char *argv[]
)
{
    unsigned32 status;
    rpc_binding_vector_t *binding_vector;

    if (argc &lt; 2) {
        fprintf(stderr, "usage: greet_server &lt;CDS pathname>&bsol;n");
        exit(1);
    }

    /* 
     * Register interface with RPC runtime.
     */
    rpc_server_register_if(greetif_v1_0_s_ifspec, NULL, NULL,
	&amp;status);
    ERROR_CHECK(status, "Can't register interface");

    /* 
     * Use all protocol sequences that are available.
     */
    rpc_server_use_all_protseqs(rpc_c_protseq_max_reqs_default,
	&amp;status);
    ERROR_CHECK(status, "Can't use protocol sequences");

    /* 
     * Get the binding handles generated by the runtime.
     */
    rpc_server_inq_bindings(&amp;binding_vector, &amp;status);
    ERROR_CHECK(status, "Can't get bindings for server");

    /* 
     * Register assigned endpoints with endpoint mapper.
     */
    rpc_ep_register(
        greetif_v1_0_s_ifspec, binding_vector, NULL, 
        (unsigned_char_p_t) "greet server version 1.0", &amp;status);
    ERROR_CHECK(status, "Can't register with endpoint map");

    /* 
     * Export ourselves into the CDS namespace.
     */
    rpc_ns_binding_export(
        rpc_c_ns_syntax_default, (unsigned_char_p_t) argv[1], 
        greetif_v1_0_s_ifspec, binding_vector, NULL, &amp;status);
    ERROR_CHECK(status, "Can't export into CDS namespace");

    /*
     * Start listening for calls.
     */
    printf("Listening...&bsol;n");

    rpc_server_listen(rpc_c_listen_max_calls_default, &amp;status);
    ERROR_CHECK(status, "Can't start listening for calls");

    /*
     * Unregister from endpoint mapper.
     */
    rpc_ep_unregister(
        greetif_v1_0_s_ifspec, binding_vector, NULL, &amp;status);
    ERROR_CHECK(status, "Can't unregister from endpoint map");
}
